# 如何连线便携式无线打印机

相关框架：`PrinterDispatch.framework`



### 连接打印机

```objective-c
    [[PTDispatcher share] scanBLEPrinter:^(PTPrinter *printer) {
        // 发现新打印机
    }];
    
    [[PTDispatcher share] scanBLEPrinters:^(NSDictionary *printerDict) {
       // 发现打印机，返回当前已搜索到的所有打印机
       // 如果要显示蓝牙列表，可以在这里把 Dictionary 中的值绑定 TableView, 直接刷新 Table
    }];
    
    [[PTDispatcher share] connectPrinter:printer]; 	//连接指定的打印机
    [[PTDispatcher share] disConnectPrinter]; 		// 断开与打印机的连接
    [[PTDispatcher share] stopScanBluetooth]; 		// 停止蓝牙扫描
```



###  获取打印机状态

```objective-c
	[[PTDispatcher share] whenConnectSuccess:^{
        // 当连接打印机成功
    }];
    
    [[PTDispatcher share] whenConnectFailure:^{
        // 当连接打印机失败
    }];
    
    [[PTDispatcher share] whenUnconnect:^{
        // 当与打印机断开
    }];
    
    [[PTDispatcher share] whenReadRSSI:^(NSNumber *RSSI) {
        // 当更新已连接打印机的信号强度 RSSI
    }];
    
    [[PTDispatcher share] whenReceiveData:^(NSData *receiveData) {
       // 收到打印机返回的数据
    }];
```



