//
//  PTTableView.h
//
//  Created by midmirror on 16/1/29.
//  Copyright © 2016年 midmirror. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "FlatPublicDefine.h"

typedef NS_ENUM(NSInteger,FlatTableMode) {
    
    FlatTableModeBluetooth = 0,
    FlatTableModeBitmap,
    FlatTableModeNormal,
    FlatTableModeTextAdaptive,
};

typedef NS_ENUM(NSInteger,FlatTableDataIndex) {
    
    Text = 0,
    DetailText,
    ContentView,
};

@interface FlatTableKit : UIView<UITableViewDataSource,UITableViewDelegate>

singletonH(FlatTableKit)

@property(strong,nonatomic,readwrite) UITableView *tableView;

/**
 *  表视图的数据源
 */
@property(strong,nonatomic,readwrite) NSArray *dataArray;

/**
 *  表视图的展示模式
 */
@property(nonatomic) FlatTableMode tableMode;

/**
 *  初始化一个表视图组件
 *
 *  @param width     视图的宽度
 *  @param height    视图的高度
 *  @param dataArray 视图的数据源，注意程序中如何构建一个合理的数组
 *  @param tableMode 展示模式
 *  @param checkMark 是否显示导向箭头
 *
 *  @return 表视图
 */
- (id)initWithWidth:(float)width Height:(float)height DataArray:(NSArray *)dataArray TableMode:(FlatTableMode)tableMode CheckMark:(BOOL)checkMark;

@end
