//
//  PTPageVC.m
//
//  Created by midmirror on 15/12/28.
//  Copyright © 2015年 midmirror. All rights reserved.
//

#import "PTPageVC.h"
#import "Masonry.h"
#import "PTPrinterPort.h"

@interface PTPageVC ()

@property(strong,nonatomic,readwrite) NSDictionary *tableRowDic;
@end

@implementation PTPageVC

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    UILabel *titleLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 0 , 200, 44)];
    titleLabel.backgroundColor = [UIColor clearColor];
    titleLabel.font = [UIFont systemFontOfSize:20];
    titleLabel.textColor = [UIColor whiteColor];//设置文本颜色
    titleLabel.textAlignment = NSTextAlignmentCenter;
    titleLabel.text = @"Page Print";
    self.navigationItem.titleView = titleLabel;
    
    [self setupDataSource];
    [self setupFlatUI];
    [self setupFootTable];

    _tableKit = [FlatTableKit share];
    
}

- (void)notificationUserSelectCell:(NSNotification *)sender {
    
    _tableRowDic = [sender userInfo];
    [self popPickerViewAt:[[_tableRowDic objectForKey:@"row"] intValue]];
}

- (void)setupFlatUI {
    
    UIColor *headColor = FLAT_COLOR_BLUE;
    UIColor *footColor = FLAT_COLOR_COULD;
    _flatView = [[FlatMainView alloc] initWithWidth:SCREEN_WIDTH Height:SCREEN_HEIGHT splitPercentage:0.4 headColor:headColor footColor:footColor];
    [self.view addSubview:_flatView];
    
    [_flatView.textView setText:@"Xiamen Hanin Electronic Technology Co., Ltd."];
    
    [_flatView.textView mas_makeConstraints:^(MASConstraintMaker *make) {
        
        make.centerX.equalTo(self.view.mas_centerX);
        make.top.equalTo(self.view.mas_top).offset(SCREEN_HEIGHT*0.03);
        make.size.mas_equalTo(CGSizeMake(SCREEN_WIDTH * 0.8, SCREEN_WIDTH * 0.15));
    }];
    
    _flatView.mainButton.hidden = NO;
    [_flatView.mainButton setTitle:NSLocalizedString(@"Send To Print", nil) forState:UIControlStateNormal];
    [_flatView.mainButton addTarget:self action:@selector(sendToPrinterAction) forControlEvents:UIControlEventTouchUpInside];
    
    CGFloat buttonWidth = [FlatFit getMainButtonWidth];
    CGFloat buttonHeight = [FlatFit getMainButtonHeight];
    
    [_flatView.mainButton mas_makeConstraints:^(MASConstraintMaker *make) {
        
        make.centerX.equalTo(self.view);
        make.bottom.equalTo(_flatView.headView.mas_bottom).offset(-SCREEN_HEIGHT*0.03);
        make.size.mas_equalTo(CGSizeMake(buttonWidth, buttonHeight));
    }];
}

- (void)updateTitleAndParameter:(NSNumber *)row {
    
    if (row) {
        
        int rowInt = [row intValue];
        FlatToolBox *tool = [[FlatToolBox alloc] init];
        NSString *newDetailTitle = [tool pieceStringWithArray:[FlatPickerKitModel share].titleArray];
        
        if ((rowInt !=6 )) {
            
            newDetailTitle = [NSString stringWithFormat:@"%d",[newDetailTitle intValue]];
           [_parameterArray replaceObjectAtIndex:rowInt withObject:newDetailTitle];
        }else {
            
            NSString *pickerRow = [[FlatPickerKitModel share].rowArray[0] stringValue];
            [_parameterArray replaceObjectAtIndex:rowInt withObject:pickerRow];
        }
        [_detailTextArray replaceObjectAtIndex:[row integerValue] withObject:newDetailTitle];
    }
}

- (void)setupFootTable {
    
//    NSArray *titleArray = @[@"LeftMargin(0≤n≤383)",@"TopMargin(0≤n≤935)",@"Width(0≤n≤384)",@"Height(0≤n≤936)",@"X coordinate",@"Y coordinate",@"Direction"];
    NSArray *titleArray = @[NSLocalizedString(@"Left Margin", nil),
                            NSLocalizedString(@"Top Margin", nil),
                            NSLocalizedString(@"Width", nil),
                            NSLocalizedString(@"Height", nil),
                            NSLocalizedString(@"X Coordinate", nil),
                            NSLocalizedString(@"Y Coordinate", nil),
                            NSLocalizedString(@"Direction", nil)];
    
    NSArray *tableDataArray = @[titleArray,_detailTextArray];
    
    _tableKit = [[FlatTableKit alloc] initWithWidth:SCREEN_WIDTH Height:SCREEN_HEIGHT*0.6 DataArray:tableDataArray TableMode:FlatTableModeNormal CheckMark:NO];
    
    [_flatView.footView addSubview:_tableKit];
}

- (void)popPickerViewAt:(int)row {
    
    UIColor *headColor = FLAT_COLOR_GRAY;
    
    _popView = [[FlatPopView alloc] initWithWidth:SCREEN_WIDTH*0.6 Height:SCREEN_HEIGHT*0.4 splitPercentage:0.2 headColor:headColor];
    _popView.titleLabel.text = NSLocalizedString(@"Please Select", nil);
    
    __block FlatPopView *popView = _popView;
    __block PTPageVC *pageVC = self;
    [_popView addButtonWithTitle:NSLocalizedString(@"OK", nil) handler:^(FlatPopViewButton *button) {
        
        [popView hideAnimation];
        [pageVC updateTitleAndParameter:[NSNumber numberWithInt:row]];
        [pageVC setupFootTable];
    }];
    
    [_popView show];
    
    FlatToolBox *tool = [[FlatToolBox alloc] init];
    NSArray *dataArray;
    
    NSArray *numberArray = @[@383,@935,@284,@936,@100,@100];
    if (row !=6 ) {
        
        dataArray = [tool generateNumberArrayWith:numberArray[row]];
    }else {
        
        dataArray = @[@[@"Left to right",@"Down to up",@"Right to left",@"Up to down"]];
    }

    
    FlatPickerKit *picker = [[FlatPickerKit alloc] initWithWidth:SCREEN_WIDTH*0.6 Height:SCREEN_HEIGHT*0.4*0.8 withDataSource:dataArray];
    [_popView.footView addSubview:picker];
}


- (void)setupDataSource {
    
    _alignmentArray = @[@"Left to right",@"Down to up",@"Right to left",@"Up to down"];
    _alignmentDic = @{@"Left to right":@"0",@"Down to up":@"1",@"Right to left":@"2",@"Up to down":@"3"};
    _detailTextArray = [[NSMutableArray alloc] initWithObjects:@"0",@"0",@"100",@"100",@"0",@"0",@"Left to right", nil];
    _parameterArray = [[NSMutableArray alloc] initWithObjects:@0,@0,@100,@100,@0,@0,@0, nil];
}

- (void)sendToPrinterAction
{
    int xPos        = [_parameterArray[0] intValue];
    int yPos        = [_parameterArray[1] intValue];
    int pageWidth   = [_parameterArray[2] intValue];
    int pageHeight  = [_parameterArray[3] intValue];
    int xCoordinate = [_parameterArray[4] intValue];
    int yCoordinate = [_parameterArray[5] intValue];
    int printDirection = [_parameterArray[6] intValue];
    
    PTCommandESC *cmd = [[PTCommandESC alloc] init];
    
    [cmd setPageMode];
    [cmd pageSetPrintAreaWithXPos:xPos yPos:yPos width:pageWidth height:pageHeight];
    [cmd cancelPrint];
    [cmd pageSetPrintDirection:printDirection];
    [cmd setAbsolutePosition:xCoordinate];
    [cmd pageSetAbsoluteYPos:yCoordinate];
    [cmd appendText:_flatView.textView.text];
//    [cmd printAndReturnStandardMode];
    [cmd setStandardMode];
    
    [PTPrinterPort sendData:[cmd getCommandData]];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewWillAppear:(BOOL)animated {
    
    self.navigationController.navigationBar.barTintColor = FLAT_COLOR_BLUE;
    self.navigationController.navigationBar.alpha = 1.0;
    [self.navigationController.navigationBar setTranslucent:NO];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(notificationUserSelectCell:) name:@"NotificationUserSelectCell" object:nil];
    [super viewWillAppear:YES];
}

- (void)viewWillDisappear:(BOOL)animated {
    
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    [super viewWillDisappear:YES];
}

@end
